<?php

/*
 * checks what DEF variables are present in cdef and returns them as array
 */
function cdef_components($cdef_string) {
	preg_match_all('/([a-z]{1,3})/',$cdef_string,$match);
	/*
	$tmp_match:
	[0] => a
	[3] => b
	*/
	return array_unique($match[0]);
}

/*
 * converts hexadecimal color representation to it's decimal form
 * in style "255,0,128"
 */
function hex2dec($hex) {
    $res=explode("\n",trim(chunk_split($hex,2)));
    foreach ($res as $id => $hex) 
	$res[$id] = hexdec($hex);
    $res = implode(",",$res);
    return $res;
}

/*
 * cleans titles from garbage (like %&$#) before passing it to the java-applet 
 */
function clean($str) {
    //return preg_replace('/\W+/',' ',$str); //sometimes in titles apear "%" sign and java-applet is unable to handle it as string
    //rrdtool output encloses titles with ""
    $str = str_replace('\"','^^',$str);
    $str = str_replace('"','',$str);
    $str = str_replace('^^','"',$str);
    $str = str_replace(',',';',$str);
    $str = str_replace('\:','',$str);
    return $str;
}

/*
 * checks string against non-aplhanumeric characters
 */
function check_string($str) {
    if ( preg_match('/[^\w+]/i', $str) )
	return false;
    else 
	return true;
}

function input_validate_input_regexp($str,$rgxp) {
    if ( preg_match($rgxp, $str) )
	return true;
    else 
	die_html_input_error();
}

/*
 * checks if value is present in array and returns key
 */
function present($needle,$haystack) {
    if (in_array($needle,$haystack)) {
            $tmp=array_flip($haystack);
            return $tmp[$needle];
    }
    return false;
}

/*
 * returns las key of an array
 */
function last_key($array) {
    return end(array_keys($array));
}

/*
 * saves output to the file (for debugging purposes)
 */
function write_file($file,$path,$content,$type) {
    if ($handle = fopen($path."/".$file,$type)) {
	$stat = fwrite($handle,$content);
	fclose($handle);
	if ($stat) return true;
    }
    return false;
}

/*
 *fully encodes string in base64
 */
function encode_base64($string) {
    $string = base64_encode($string);
    $string = str_replace(array('+','/','='),array('-','_','.'),$string);
    return $string;
}

/*
 * fully decodes base64 string
 */
function decode_base64($string) {
    $string = str_replace(array('-','_','.'),array('+','/','='),$string);
    $string = base64_decode($string);
    return $string;
}

/* 
 * searches for substring in array key
 */
function assoc($arr2look,$key) {
    foreach ($arr2look as $string)
        if (stristr($string,$key)) return $string;
    return false;
}

/*
 * outputs an error and terminates further processing
 */
function err_to_browser($err) {
    echo "
    <HTML>
     <HEAD>
	<TITLE>ZOND ERROR</TITLE>
    </HEAD>
    <BODY bgcolor = #F9F9F9>
	<TABLE width=100% height=100%>
	    <TR><TD align=middle>
		<strong><font color=red>ERROR:$err</font></strong>
	    </TD></TR>
	</TABLE>
    </BODY>
    </HTML>
    ";
    
    die();
}

function scatter($text, $key = '') {
    // return text unaltered if the key is blank
    if (empty($key)) {
        return $text;
    }

    // remove the spaces in the key
    $key = str_replace(' ', '', $key);

    // set key length to be no more than 32 characters
    $key_len = strlen($key);
    if ($key_len > 32) {
        $key_len = 32;
    }

    // A wee bit of tidying in case the key was too long
    $key = substr($key, 0, $key_len);

    // We use this a couple of times or so
    $text_len = strlen($text);

    // fill key with the bitwise AND of the ith key character and 0x1F, padded to length of text.
    $lomask = str_repeat("\x1f", $text_len); // Probably better than str_pad
    $himask = str_repeat("\xe0", $text_len);
    $k = str_pad("", $text_len, $key); // this one _does_ need to be str_pad

    // {en|de}cryption algorithm
    $text = (($text ^ $k) & $lomask) | ($text & $himask);

    return $text;
}

/*
 * checks if apropriate setting is enabled in php.ini
 */
function check_ini_vars() {
    if (ini_get('register_argc_argv')!=1)
	err_to_browser('ZOND plugin requires "register_argc_argv=On" in php.ini');
}

/*
 * splits string into chunks and returns them as an array (implies str_split on php5)
 */
function str_splt($text, $split = 1) {

    if (function_exists('str_split')) 
	return array_unique(str_split($text,$split));
    
    if (!is_string($text) || (!is_numeric($split) || $split < 1) ) return false;
    
    $len = strlen($text);
    $array = array();
    $i = 0;

    while ($i < $len) {
        $key = NULL;
        
	for ($j = 0; $j < $split; $j += 1) { 
	    if ($i == $len) break;
	    $key .= $text{$i};
            $i += 1;    
        }
        
        $array[] = $key;
    }
    
    return $array;
}

/*
 * returns an array consiting of two arrays (implies array_combine on php5)
 */
function array_cmbn($arr1,$arr2) {

    if (function_exists('array_combine'))
	return array_combine($arr1,$arr2);

    $out = array();
    foreach($arr1 as $key1 => $value1) {
	$out[$value1] = $arr2[$key1];
    }
    return $out;
}

/*
 * returns files in /templates folder as an array
 */
function get_templates() {
    if ($handle = opendir('./templates/'))
        while (false !== ($file = readdir($handle)))
            if(!is_dir($file) && ($file!='.' || $file!='..') )
                $templates[] = $file;
}

/*
 * converts RGB color value to HSL color
 */
function rgb2hsl($rgb) {
    $r = $rgb[0] / 255;
    $g = $rgb[1] / 255;
    $b = $rgb[2] / 255;
    
    $min = min($r, $g, $b);
    $max = max($r, $g, $b);
    
    switch ($max) {
    case 0:
        $h = $s = $l = 0;
        break;
    case $min:
        $h = $s = 0;
        $l = $max;
        break;
    default:
        $delta = $max - $min;
        if( $r == $max ) $h = 0 + ( $g - $b ) / $delta;
        else if( $g == $max ) $h = 2 + ( $b - $r ) / $delta;
	else $h = 4 + ( $r - $g ) / $delta;

        $h *= 60;
        if($h < 0 ) $h += 360;

        $s = $delta;
        $l = ($max + $min) / 2;
    }
    
    return array($h, $s, $l);
}

/*
 * converts HSL color value to RGB color
 */
function hsl2rgb($hsl) {
    $h = $hsl[0];
    $s = $hsl[1];
    $l = $hsl[2];
    
    $h /= 360;
    
    if ($s == 0.0) {
        $r = $g = $b = $l;
    } else {
        if ($l < 0.5) $temp2 = $l * (1.0 + $s);
        else $temp2 = ($l + $s) - ($l * $s);

        $temp1 = (2.0 * $l) - $temp2;
        $r = hue2rgb($temp1, $temp2, $h + (1 / 3));
        $g = hue2rgb($temp1, $temp2, $h);
        $b = hue2rgb($temp1, $temp2, $h - (1 / 3));
    }
    
    return(array(
	    (int)($r * 255 + 0.5),
	    (int)($g * 255 + 0.5),
	    (int)($b * 255 + 0.5)
    ));
}

/*
 * converts HUE color value to RGB color
 */
function hue2rgb( $v1, $v2, $vH ) {
    if ( $vH < 0 ) $vH += 1;
    
    if ( $vH > 1 ) $vH -= 1;
    
    if ( 6 * $vH < 1 ) return $v1 + ( $v2 - $v1 ) * 6 * $vH;
    elseif ( 2 * $vH < 1 ) return $v2;
    elseif ( 3 * $vH < 2 ) return $v1 + ( $v2 - $v1 ) * ( ( 2 / 3 ) - $vH ) * 6;
    else return $v1;
}

/*
 * darkens RGB color by N percent
 */
function darken($rgb_col,$perc) {
    $RGB = explode(',',$rgb_col);
    $RGB=shape($RGB,0,255);
    $perc = shape($perc,0,100);
    
    $hsl = rgb2hsl($RGB);
    
    $hsl[2] = $hsl[2]*($perc/100);
    
    $rgb_d = shape(hsl2rgb($hsl),0,255);
    return implode(',',$rgb_d);
}

/*
 * lightens RGB color by N percent
 */    
function lighten($rgb_col,$perc) {
    $RGB = explode(',',$rgb_col);
    $RGB=shape($RGB,0,255);
    $perc = shape($perc,0,100);
    
    $hsl = rgb2hsl($RGB);
    	
    $hsl[2] = $hsl[2]*(1+$perc/100);
    
    $rgb_d = shape(hsl2rgb($hsl),0,255);
    return implode(',',$rgb_d);    
}

/*
 * checks value against specified range
 */
function shape($val,$from,$to) {
    if (is_array($val)) {
        foreach ($val as $i => $j) 
    	    if ($j > $to) $val[$i] = $to;
	    elseif ($j < $from) $val[$i] = $from;
	} elseif (is_numeric($val)) {
    	    if ($val > $to) $val = $to;
	    elseif ($val < $from) $val = $from;
	} else {
	    $val = 0;
	}
	
	return $val;
}

/*
 * enquotes a string or array
 */
function enquote($data,$separator=" ",$quotesymb="\"") {
    if (!is_array($data)) {
	$new_val=explode($separator,$data);
	foreach ($new_val as $item => $sub_val) {
	    $sub_val=trim($sub_val);
	    if (!empty($sub_val))
		$new_val[$item]=$quotesymb.$sub_val.$quotesymb;
	}
	$data=implode($separator,$new_val);
    } else {
	foreach ($data as $id => $val) {
	    if (is_array($val)) {
		$data[$id]=enquote($val,$separator,$quotesymb);
	    } else {
		$new_val=explode($separator,$val);
		foreach ($new_val as $item => $sub_val) {
		    $sub_val=trim($sub_val);
		    if (!empty($sub_val))
			$new_val[$item]=$quotesymb.$sub_val.$quotesymb;
		}
		$data[$id]=implode($separator,$new_val);
	    }
	}
    }
    return $data;
}

/*
 * dequotes a string or array
 */
function dequote($data,$separator=" ",$quotesymb="\"") {
    if (!is_array($data)) {
	$new_val=explode($separator,$data);
	foreach ($new_val as $item => $sub_val) {
	    $sub_val=trim($sub_val);
	    $new_val[$item]=str_replace($quotesymb,"",$sub_val);
	}
	$data=implode($separator,$new_val);
    } else {
	foreach ($data as $id => $val) {
	    if (is_array($val)) {
		$data[$id]=enquote($val,$separator,$quotesymb);
	    } else {
		$new_val=explode($separator,$val);
		foreach ($new_val as $item => $sub_val) {
		    $sub_val=trim($sub_val);
		    $new_val[$item]=str_replace($quotesymb,"",$sub_val);
		}
		$data[$id]=implode($separator,$new_val);
	    }
	}
    }
    return $data;
}

/*
 * returns snmp result-string(using cacti built-in function) and snmp-query duration
 */
function snmp_data($oid) {
    global $snmp_details;
    $d=$snmp_details;

    $timePrev=time() + microtime();
	$result=(count($d)>7) ? cacti_snmp_get($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['auth_proto'], $d['priv_pass'], $d['priv_proto'], $d['context'], $d['port'], $d['timeout']) :
	 cacti_snmp_get($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['port'], $d['timeout']);
    $timeDelta=time() + microtime() - $timePrev;

    if ($result===false || $result=="" || $result=="U" || stristr($result,"No Such")) {
        return array("NaN",$timeDelta);
    } else {
	$result = trim(substr($result,strrpos($result,":")+2));
	return array((intval($result)==0) ? 0 : $result, $timeDelta);
    }
}

/*
 * returns snmp result-array using cacti built-in function
 */
function snmp_data_array($oid) {
    global $snmp_details;
    $d=$snmp_details;

    snmp_set_oid_numeric_print(1);
    snmp_set_enum_print(TRUE);

    $result=(count($d)>7) ? cacti_snmp_walk($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['auth_proto'], $d['priv_pass'], $d['priv_proto'], $d['context'], $d['port'], $d['timeout']) :
     cacti_snmp_walk($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['port'], $d['timeout']);

    return $result;
}

/*
 * translates CF in human readable format
 */
function cf_hrf($cf) {

    switch ($cf) {
	case 1:
	    return "AVERAGE";
	case 2:
	    return "MIN";
	case 3:
	    return "MAX";
	case 4;
	    return "LAST";
	default :
	    return false;
    }
}

/*
 * some definitions here to avoid code doubling in scripts
 */
$zond_config_params = array (
                            'width',
                            'height',
			    'autosize',
			    'scaletype',
			    'charttype',
                            'refresh',
                            'font_name',
                            'font_size',
                            'axis_pos',
                            'axis_rot',
                            'indicator',
                            'values',
			    'legtype',
                            'contour',
                            'majhorz',
                            'majvert',
                            'minvert',
                            'minhorz',                
                            'trans',
			    'user',
			    'pass',
			    'hash',
			    'hashed',
			    'hash_blcksize',
			    'security'
            );

$fonts = array (
                "Arial",                              
                "Arial Rounded MT Bold",              
                "Bitstream Vera Sans Mono",           
                "Century Gothic",                     
                "Courier",                            
                "Courier New",                        
                "Lucida Sans",                        
                "MS Reference Sans Serif",
                "Tahoma"
                );

$php_bin_path = read_config_option("path_php_binary");

$PROTO = ( isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on' ) ? 'https://' : 'http://' ;

?>
